/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.18 from the
 * contents of MongoClient.xs. Do not edit this file, edit MongoClient.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "xs/MongoClient.xs"
/*
 *  Copyright 2009-2013 MongoDB, Inc.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

#include "perl_mongo.h"
#include "mongo_link.h"

static int
connection_free (pTHX_ SV *sv, MAGIC *mg)
{
    mongo_link *link;

    PERL_UNUSED_ARG(sv);

    link = (mongo_link *)mg->mg_ptr;

    if (!link->copy && link->master) {
        if (link->master->host) {
            Safefree(link->master->host);
        }

        Safefree(link->master);
    }

    Safefree(link);

    mg->mg_ptr = NULL;

    return 0;
}

static int
connection_clone (pTHX_ MAGIC *mg, CLONE_PARAMS *params)
{
    mongo_link *link, *new_link;

    PERL_UNUSED_ARG (params);

    link = (mongo_link *)mg->mg_ptr;

    Newx(new_link, 1, mongo_link);
    Copy(link, new_link, 1, mongo_link);

    if (link->master) {
        mongo_server *new_master;

        Newx(new_master, 1, mongo_server);
        new_master->host = savepv(link->master->host);
        new_master->port = link->master->port;

        /* Start out disconnected. When we have something to send, we'll
         * reconnect automatically.
         *
         * If we actually wanted to reconnect here, we'd have to make mongo_link
         * carry around a backref to the SV it's associated with so we could
         * reconnect through perl space.
         */
        new_master->connected = 0;

        new_link->master = new_master;
    }


    mg->mg_ptr = (char *)new_link;

    return 0;
}

MGVTBL connection_vtbl = {
    NULL,
    NULL,
    NULL,
    NULL,
    connection_free,
#if MGf_COPY
    NULL,
#endif
#if MGf_DUP
    connection_clone,
#endif
#if MGf_LOCAL
    NULL,
#endif
};

#line 108 "xs/MongoClient.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 250 "xs/MongoClient.c"

XS_EUPXS(XS_MongoDB__MongoClient__init_conn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MongoDB__MongoClient__init_conn)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, host, port, ssl");
    {
	SV *	self = ST(0)
;
	char *	host = (char *)SvPV_nolen(ST(1))
;
	int	port = (int)SvIV(ST(2))
;
	bool	ssl = (bool)SvTRUE(ST(3))
;
#line 109 "xs/MongoClient.xs"
    SV *auto_reconnect_sv = 0, *timeout_sv = 0;
    mongo_link *link;
#line 270 "xs/MongoClient.c"
#line 112 "xs/MongoClient.xs"
    Newx(link, 1, mongo_link);
    perl_mongo_attach_ptr_to_instance(self, link, &connection_vtbl);

    /*
     * hosts are of the form:
     * [{host => "host", port => 27017}, ...]
     */
    Newx(link->master, 1, mongo_server);
    link->master->host = savepv(host);
    link->master->port = port;
    link->master->connected = 0;
    link->ssl = ssl;
#ifdef MONGO_SSL 
    link->ssl_handle = NULL;
    link->ssl_context = NULL;
#endif
    auto_reconnect_sv = perl_mongo_call_reader (ST(0), "auto_reconnect");
    timeout_sv = perl_mongo_call_reader (ST(0), "timeout");

    link->auto_reconnect = SvIV(auto_reconnect_sv);
    link->timeout = SvIV(timeout_sv);
    link->copy = 0;

#line 295 "xs/MongoClient.c"
#line 136 "xs/MongoClient.xs"
    SvREFCNT_dec (auto_reconnect_sv);
    SvREFCNT_dec (timeout_sv);
#line 299 "xs/MongoClient.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_MongoDB__MongoClient__init_conn_holder); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MongoDB__MongoClient__init_conn_holder)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, master");
    {
	SV *	self = ST(0)
;
	SV *	master = ST(1)
;
#line 144 "xs/MongoClient.xs"
    mongo_link *self_link, *master_link;
#line 318 "xs/MongoClient.c"
#line 146 "xs/MongoClient.xs"
    Newx(self_link, 1, mongo_link);
    perl_mongo_attach_ptr_to_instance(self, self_link, &connection_vtbl);

    master_link = (mongo_link*)perl_mongo_get_ptr_from_instance(master, &connection_vtbl);

    self_link->master = master_link->master;
    self_link->copy = 1;
    self_link->ssl = master_link->ssl;
#ifdef MONGO_SSL 
    self_link->ssl_handle = master_link->ssl_handle;
    self_link->ssl_context = master_link->ssl_context;
#endif
    self_link->sender = master_link->sender;
    self_link->receiver = master_link->receiver;
#line 334 "xs/MongoClient.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_MongoDB__MongoClient_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MongoDB__MongoClient_connect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 165 "xs/MongoClient.xs"
     mongo_link *link = (mongo_link*)perl_mongo_get_ptr_from_instance(self, &connection_vtbl);
     SV *username, *password;
     IV sasl_flag;
#line 353 "xs/MongoClient.c"
#line 169 "xs/MongoClient.xs"
    perl_mongo_connect(self, link);

     if (!link->master->connected) {
       croak ("couldn't connect to server %s:%d", link->master->host, link->master->port);
     }

     // try legacy authentication if we have username and password but are not using SASL 
     username = perl_mongo_call_reader (self, "username");
     password = perl_mongo_call_reader (self, "password");
     sasl_flag = SvIV( perl_mongo_call_reader( self, "sasl" ) );

     if ( ( sasl_flag == 0 ) && SvPOK(username) && SvPOK(password)) {
       SV *database, *result, **ok;

       database = perl_mongo_call_reader (self, "db_name");
       result = perl_mongo_call_method(self, "authenticate", 0, 3, database, username, password);
       if (!result) {
         SvREFCNT_dec(database);
         SvREFCNT_dec(username);
         SvREFCNT_dec(password);
         croak("authentication returned no result");
       }
       // we're expecting either a string (failure) or a hash (success hopefully)
       if (SvPOK(result)) {
         SvREFCNT_dec(database);
         SvREFCNT_dec(username);
         SvREFCNT_dec(password);
         croak("%s", SvPV_nolen(result));
       } else if (SvROK(result)) {
         ok = hv_fetchs((HV*)SvRV(result), "ok", 0);
         if (!ok || 1 != SvIV(*ok)) {
           SvREFCNT_dec(database);
           SvREFCNT_dec(username);
           SvREFCNT_dec(password);
           croak ("couldn't authenticate with server");
         }
       } else {
         sv_dump(result);
         SvREFCNT_dec(database);
         SvREFCNT_dec(username);
         SvREFCNT_dec(password);
         croak("something weird happened with authentication");
       }

       SvREFCNT_dec(database);
     }

     SvREFCNT_dec(username);
     SvREFCNT_dec(password);
#line 404 "xs/MongoClient.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_MongoDB__MongoClient_connected); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MongoDB__MongoClient_connected)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 224 "xs/MongoClient.xs"
     mongo_link *link;
#line 423 "xs/MongoClient.c"
#line 226 "xs/MongoClient.xs"
     link = (mongo_link*)perl_mongo_get_ptr_from_instance(self, &connection_vtbl);

     if (link->master && link->master->connected) {
         RETVAL = 1;
     }
     else {
         RETVAL = 0;
     }
#line 433 "xs/MongoClient.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_MongoDB__MongoClient_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MongoDB__MongoClient_send)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, str");
    {
	SV *	self = ST(0)
;
	SV *	str = ST(1)
;
#line 243 "xs/MongoClient.xs"
         buffer buf;
         STRLEN len;
#line 454 "xs/MongoClient.c"
	int	RETVAL;
	dXSTARG;
#line 246 "xs/MongoClient.xs"
         buf.start = SvPV(str,len);
         buf.pos = buf.start+len;
         buf.end = buf.start+len;
#line 461 "xs/MongoClient.c"
#line 250 "xs/MongoClient.xs"
         RETVAL = mongo_link_say(self, &buf);
         if (RETVAL == -1) {
           die("can't get db response, not connected");
         }
#line 467 "xs/MongoClient.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_MongoDB__MongoClient_recv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MongoDB__MongoClient_recv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, cursor");
    {
	SV *	cursor = ST(1)
;
#line 262 "xs/MongoClient.xs"
         mongo_link_hear(cursor);
#line 485 "xs/MongoClient.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_MongoDB__MongoClient__compile_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MongoDB__MongoClient__compile_flags)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 269 "xs/MongoClient.xs"
        HV *flags = newHV();
#ifdef MONGO_SSL
        hv_store( flags, "--ssl",  5, newSViv( 1 ), 0 );
#endif
#ifdef MONGO_SASL
        hv_store( flags, "--sasl", 6, newSViv( 1 ), 0 );
#endif
        RETVAL = newRV_noinc( flags );
#line 510 "xs/MongoClient.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_MongoDB__MongoClient_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_MongoDB__MongoClient_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 285 "xs/MongoClient.xs"
         mongo_link *link;
#line 529 "xs/MongoClient.c"
#line 287 "xs/MongoClient.xs"
         link = (mongo_link*)perl_mongo_get_ptr_from_instance(self, &connection_vtbl);

         if (!link->copy && link->master) {
           set_disconnected(self);
         }
#line 536 "xs/MongoClient.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_MongoDB__MongoClient); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_MongoDB__MongoClient)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("MongoDB::MongoClient::_init_conn", XS_MongoDB__MongoClient__init_conn, file);
        newXS("MongoDB::MongoClient::_init_conn_holder", XS_MongoDB__MongoClient__init_conn_holder, file);
        newXS("MongoDB::MongoClient::connect", XS_MongoDB__MongoClient_connect, file);
        newXS("MongoDB::MongoClient::connected", XS_MongoDB__MongoClient_connected, file);
        newXS("MongoDB::MongoClient::send", XS_MongoDB__MongoClient_send, file);
        newXS("MongoDB::MongoClient::recv", XS_MongoDB__MongoClient_recv, file);
        newXS("MongoDB::MongoClient::_compile_flags", XS_MongoDB__MongoClient__compile_flags, file);
        newXS("MongoDB::MongoClient::DESTROY", XS_MongoDB__MongoClient_DESTROY, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

